/**
 * @copyright   2018-2019, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 */
import { types as t } from '@babel/core';
import getTypeName from './getTypeName';
export default function extractGenericTypeNames(node) {
  const names = [];

  if (t.isTSTypeParameterInstantiation(node)) {
    node.params.forEach(param => {
      names.push(...extractGenericTypeNames(param));
    });
  } else if (t.isTSTypeReference(node)) {
    names.push(getTypeName(node.typeName));
  } else if (t.isTSIntersectionType(node) || t.isTSUnionType(node)) {
    node.types.forEach(param => {
      names.push(...extractGenericTypeNames(param));
    });
  }

  return names;
}