"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = extractGenericTypeNames;

var _core = require("@babel/core");

var _getTypeName = _interopRequireDefault(require("./getTypeName"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2018-2019, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 */
function extractGenericTypeNames(node) {
  const names = [];

  if (_core.types.isTSTypeParameterInstantiation(node)) {
    node.params.forEach(param => {
      names.push(...extractGenericTypeNames(param));
    });
  } else if (_core.types.isTSTypeReference(node)) {
    names.push((0, _getTypeName.default)(node.typeName));
  } else if (_core.types.isTSIntersectionType(node) || _core.types.isTSUnionType(node)) {
    node.types.forEach(param => {
      names.push(...extractGenericTypeNames(param));
    });
  }

  return names;
}