"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getTypeName;

var _core = require("@babel/core");

/**
 * @copyright   2018-2019, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 */
function getTypeName(typeName) {
  if (_core.types.isIdentifier(typeName)) {
    return typeName.name;
  } else if (_core.types.isTSQualifiedName(typeName)) {
    return `${getTypeName(typeName.left)}.${typeName.right.name}`;
  }

  return '';
}